#include "util.h"
#include <cassert>

// Q2
Bloc voisinh(Bloc b) {
    b.x += b.w;
    return b;
}

// Q3
Bloc voisinv(Bloc b) {
    b.y += b.h;
    return b;
}

// Q4
bool operator<=(Bloc b, Bloc B) {
    return B.x<=b.x && b.x+b.w<=B.x+B.w && B.y<=b.y && b.y+b.h<=B.y+B.h;
}

// Q5
Img copie(Img in, Bloc b) {
    assert(0<=b.x && 0<=b.y && b.w>0 && b.h>0); // Q8
    assert(b.x+b.w<=in.width() && b.y+b.h<=in.height()); // Q8
    Img out(b.w,b.h);
    for(int j=0; j<b.h; j++)
        for(int i=0; i<b.w; i++)
            out(i,j) = in(b.x+i,b.y+j);
    return out;
}

// Q6
void colle(Img& im, Img vignette, int x, int y) {
    int w=vignette.width(), h=vignette.height();
    assert(0<=x && 0<=y && x+w<=im.width() && y+h<=im.height()); // Q8
    for(int j=0; j<h; j++)
        for(int i=0; i<w; i++)
            im(x+i,y+j) = vignette(i,j);
}

// Q7
void translate(Img& im, Bloc b, int dx, int dy) {
    for(int j=0; j<b.h; j++)
        for(int i=0; i<b.w; i++)
            im(b.x+i+dx,b.y+j+dy) = im(b.x+i,b.y+j);
}

// Q9 Choisir click (pour aider le debug) ou milliSleep (pour animation)
void presente_image(Img img) {
    display(img);
    // click();
    milliSleep(300);
}
